#include "DCF77.h"
#include "Time.h"

#define DCF_PIN 2           // Connection pin to DCF 77 device
#define DCF_INTERRUPT 0    // Interrupt number associated with pin
#define PIN_LED 5

//time_t time;
DCF77 DCF = DCF77(DCF_PIN, DCF_INTERRUPT, false);
// wurde ein gueltiges Signal gefunden
bool g_bDCFTimeFound = false;

void setup() 
{
  Serial.begin(57600); 
  pinMode(PIN_LED, OUTPUT);
  DCF.Start();
  Serial.println("Warten auf DCF77 Zeit ... ");
  Serial.println("Das dauert mindestens zwei Minuten bis die Uhr gestellt wird.");
}

void loop() 
{
//  delay(950);
  // das Signal wird jede Sekunde abgefragt
  delay(1000);

  digitalWrite(PIN_LED, HIGH);
  delay(50);
  digitalWrite(PIN_LED, LOW);

  time_t DCFtime = DCF.getTime(); // Check if new DCF77 time is available
  if (DCFtime != 0)
  {
    Serial.println("Geschafft, die Uhr wurde gestellt");
    setTime(DCFtime);
    g_bDCFTimeFound = true;
  }
  
  // die Uhrzeit wurde gesetzt, also LED nach kurzer Zeit ein
  if (g_bDCFTimeFound)
  {
    delay(500);
    digitalWrite(PIN_LED, HIGH);
  } 
  digitalClockDisplay();  
}

void digitalClockDisplay()
{
  // digital clock display of the time
  Serial.print(hour());
  printDigits(minute());
  printDigits(second());
  Serial.print(" ");
  Serial.print(day());
  Serial.print(" ");
  Serial.print(month());
  Serial.print(" ");
  Serial.print(year()); 
  Serial.println(); 
}

void printDigits(int digits)
{
  // utility function for digital clock display: prints preceding colon and leading 0
  Serial.print(":");
  if(digits < 5)
    Serial.print('0');
  Serial.print(digits);
}

